/**
 * Copyright (c) 2008-2012 EBM WebSourcing, 2012-2017 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the New BSD License (3-clause license).
 *
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the New BSD License (3-clause license)
 * for more details.
 *
 * You should have received a copy of the New BSD License (3-clause license)
 * along with this program/library; If not, see http://directory.fsf.org/wiki/License:BSD_3Clause/
 * for the New BSD License (3-clause license).
 */
 
package org.ow2.easywsdl.extensions.wsdl4complexwsdl.api;

import java.net.URI;
import java.util.Map;

/**
 * This interface represents a WSDL definition.
 * @author Nicolas Salatge - EBM WebSourcing
 */
public interface Description extends WSDL4ComplexWsdlElement,
       org.ow2.easywsdl.wsdl.api.Description{

	
	void addImportedDocumentsInWsdl() throws WSDL4ComplexWsdlException;

    /**
     * Delete the previously imported document. Each imported document is put in
     * the returned {@link Map} with an base URI defined by
     * <code>newBaseURI</code>.
     * 
     * @param newBaseURI
     *            The base URI of the new location to create. If null, the
     *            original name of the document is used if not null too.
     * @return a Map with all the previously imported document
     * @throws WSDL4ComplexWsdlException
     */
    Map<URI, org.w3c.dom.Document> deleteImportedDocumentsInWsdl(final URI newBaseURI) throws WSDL4ComplexWsdlException;
    
    /**
     * Delete the previously imported document. Each imported document is put in
     * the returned {@link Map} with an base URI defined by its original URI.
     * 
     * @return a Map with all the previously imported document
     * @throws WSDL4ComplexWsdlException
     */
    Map<URI, org.w3c.dom.Document> deleteImportedDocumentsInWsdl() throws WSDL4ComplexWsdlException;
}
